/**
 * @author dochmann
 */

import mx.utils.Delegate;
import mx.events.EventDispatcher;
import de.davidochmann.utilities.dogesture.register.events.RegisterEvent;

class de.davidochmann.utilities.dogesture.register.Register extends EventDispatcher 
{
	private static var mInstance:Register;
	private var mSurface:MovieClip;
	
	
	private function Register()
	{
		super();
		EventDispatcher.initialize(this);
	}

	public static function getInstance():Register
	{
		if(! mInstance)
			mInstance = new Register();
			
		return mInstance;
	}

	
	public function start():Void
	{
		mSurface.onMouseMove = Delegate.create(this, surfaceMouseMoveHandler);
		mSurface.onMouseDown = Delegate.create(this, surfaceMouseDownHandler);
		mSurface.onMouseUp   = Delegate.create(this, surfaceMouseUpHandler);
	}

	
	public function getSurface():MovieClip
	{
		return mSurface;
	}

	public function setSurface(pSurface:MovieClip):Void
	{
		mSurface = pSurface;
	}


	private function surfaceMouseMoveHandler():Void
	{
		dispatchEvent(new RegisterEvent(RegisterEvent.MOUSE_GESTURE_MOVE, this));
	}
	
	private function surfaceMouseDownHandler():Void
	{
		dispatchEvent(new RegisterEvent(RegisterEvent.MOUSE_GESTURE_DOWN, this));
	}
	
	private function surfaceMouseUpHandler():Void
	{
		dispatchEvent(new RegisterEvent(RegisterEvent.MOUSE_GESTURE_UP, this));
	}


	public function addEventListener(type:String, listener:Object):Void{};
	
	public function removeEventListener(type:String, listener:Object):Void{};
	
	private function dispatchEvent(event:Object):Void{};
}
