package de.davidochmann.utilities.dogesture.stack 
{
	/**
	 * @author dochmann
	 */

	import de.davidochmann.utilities.dogesture.interfaces.IMove;	
	 
	public class Stack 
	{
		private var mList:Array;
		private var mActive:IMove;
		private var mIndex:uint;
		private var mComplete:Boolean;
		
		
		public function Stack()
		{
			initList();
			initIndex();
			initComplete();
		}
		

		public function list():Array
		{
			return mList;
		}

		public function active():IMove
		{
			return mActive;
		}

		public function complete():Boolean
		{
			return mComplete;
		}

		public function index():uint
		{
			return mIndex;
		}

		public function add(pMove:IMove):void
		{
			mList.push(pMove);
			initActive();
		}

		public function reset():void
		{
			initIndex();
			initActive();
			initComplete();
		}
		
		
		public function next():void
		{
			if(mIndex + 1 == mList.length)
			{
				mIndex++;
				mComplete = true;
				return;
			}
				
			mIndex++;
			mActive = mList[mIndex];
		}

		
		public function initList():void
		{
			mList = new Array();
		}
		
		public function initIndex():void
		{
			mIndex = 0;
		}
		
		private function initActive():void
		{
			mActive = IMove(mList[mIndex]);
		}

		public function initComplete():void
		{
			mComplete = false;
		}
	}
}
